// 宇宙船を操縦してアステロイドを避ける
// 左右ボタンで移動
// STARTボタンを押すと終了します

// イメージデータについて (KI02)
//http://www.picosoft.co.jp/ORANGE-light/image1616.html
//Copyright (c) 2019 Picosoft Co., Ltd.
//Made by Kaori Hanatsumi

' 色定数の定義
WHITE = rgb(255, 255, 255)
ORANGE = rgb(255, 163, 0)
BLACK = 0

' ボタンの定義
BUTTON_LEFT = 7
BUTTON_RIGHT = 6
BUTTON_START = 9

' スプライトパターン定義
IMG_METEOR = getmptr()
mdata 0,0x38,0x7c,0xee,0xfa,0xf6,0x7c,0x38

IMG_KI02 = getmptr()
mdata 0x00, 0x00, 0x00, 0x80, 0x01, 0xC0, 0x01, 0x40, 0x02, 0xA0, 0x06, 0xA0, 0x07, 0xF0, 0x0D, 0xD8, 0x19, 0xC8, 0x19, 0xCC, 0x3F, 0xFC, 0x7E, 0x7E, 0x7A, 0x5E, 0xF2, 0x4F, 0x60, 0x06, 0x00, 0x00

' 構造体 メモリー確保
N=10

SP = getmptr()
mptr SP + 8*N
// struct
// +0:x
// +2:y  (F10.6)
// +4:sy (F10.6)
// +6:col (RGB565)


' 構造体 初期化
for i=0 to N-1
	sp_x_set(i,rnd(312))
	sp_y_set(i,rnd(500))
	sp_sy_set(i,24+rnd(40))
	sp_col_set(i,rgb(rnd(100)+155,50,0))
next

cls 2

x = 152<<6
vx = 0
' スプライト作成・表示
sprnew(1, x>>6, 240-16, 16, 16, IMG_KI02, WHITE, BLACK)
sprdsp 1,1

f=0
' メインループ
while in(BUTTON_START) && !f
	for i=0 to N-1
		move_meteor(i)
	next
	move_self()
	for i=0 to N-1
		f=f+hit_check(i)
	next
wend
if !f then end

' ゲームオーバー
gprint 120,100,"GAME OVER",WHITE,0
gprint 80,120,"Push START to Exit",ORANGE,0
beep 10,200

' STARTボタンが押されるまで待つ
while in(BUTTON_START)
wend
end

def move_meteor(n) {
	var y
	y=sp_y(n)+sp_sy(n)
	sp_y_set(n,y)
	if y>(232<<6) then rect sp_x(n),232,8,8,BLACK,1:sp_x_set(n,rnd(312)):sp_y_set(n,0)
	sprnew(0,sp_x(n),sp_y(n)>>6,8,8,IMG_METEOR,sp_col(n),BLACK)
	sprdsp 0,1
}
def move_self() {
	vx = vx - !in(BUTTON_LEFT)*2 + !in(BUTTON_RIGHT)*2
	vx = vx - sgn(vx) + (vx<-63) - (vx>63)
	x = x + vx
	if x<0 then x=0
	if x>(304<<6) then x=304<<6
	sprmov 1,x>>6,240-16
}

def hit_check(n) {
	var mx
	if sp_y(n)<(216<<6) then return 0
	mx = sp_x(n)
	if ( mx+7 < x>>6 ) or (x>>6 < mx-16) then return 0
	return 1
}

def sgn(n) {
	return (n>0) - (n<0)
}

' 構造体アクセス関数
def sp_x(i) {
	return mpeekw(SP/2 + i*4)
}
def sp_y(i) {
	return mpeekw(SP/2 + i*4 +1)
}
def sp_sy(i) {
	return mpeekw(SP/2 + i*4 +2)
}
def sp_col(i) {
	return mpeekw(SP/2 + i*4 +3)
}
def sp_x_set(i,n) {
	mpokew SP/2 + i*4,n
}
def sp_y_set(i,n) {
	mpokew SP/2 + i*4 +1,n
}
def sp_sy_set(i,n) {
	mpokew SP/2 + i*4 +2,n
}
def sp_col_set(i,n) {
	mpokew SP/2 + i*4 +3,n
}
